package com.yizhi.comment.application.vo.domain;

import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 回复
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
@Data
@ApiModel(value = "NewReplyVo", description = "回复")
@TableName("new_reply")
public class NewReplyVo {

    private static final long serialVersionUID = 1L;

	private Long id;

    @ApiModelProperty(value = "业务id")
	
	private Long bizId;

    @ApiModelProperty(value = "业务名称")
	
	private String bizName;

    @ApiModelProperty(value = "业务类型  0课程 2：论坛 7培训项目 15专辑")
	
	private Integer bizType;
    
    @ApiModelProperty(value = "评论id")
	
	private Long commentId;
    
    @ApiModelProperty(value = "被回复人id(评论人或者回复人)")
	
	private Long commenterId;

    @ApiModelProperty(value = "回复父级id")
	
	private Long replyParentId;
    
    @ApiModelProperty(value = "回复内容")
	private String content;

    
    private Long createById;

    
    private String createByName;
    
	
	private Date createTime;
    
    
    private Long updateById;

    
    private String updateByName;

    
    private Date updateTime;

    @ApiModelProperty(value = "0:删除 1:上架 2:下架")
	private Integer state;

    @ApiModelProperty(value = "头像")
	
    private String userAvatar;
    
    @ApiModelProperty(value = "被回复人姓名")
	
    private String commenterName;

    @ApiModelProperty(value = "用于论坛--我的回复是否已读 0:未读（默认）")
    
    private Integer isRead;

    @ApiModelProperty(value = "是否是楼主  true:是")
    
    private Boolean isAuthor = false;

    @ApiModelProperty(value = "是否是自己创建的评论 true：是")
    
    private Boolean isSelf = false;

    @ApiModelProperty(value = "是否被禁言 true：是")
    
    private Boolean hasForbidden = false;
}
