package com.yizhi.application.controller.remote;


import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.application.service.IInformRecordService;
import com.yizhi.comment.application.feign.InformRecordClient;
import com.yizhi.comment.application.vo.InformRecordVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author taoge123
 * @since 2020-01-16
 */
@RestController(value = "InformRecordControllerRemote")
@RequestMapping("/remote/informRecord")
public class InformRecordController implements InformRecordClient {

    @Autowired
    private IInformRecordService informRecordService;

    @Override
    @PostMapping("/save")
    public Integer save(@RequestBody InformRecordVo informRecordVo) {
        return informRecordService.save(informRecordVo);
    }

    @Override
    @GetMapping("/getPage")
    public Page<InformRecordVo> getPage(@RequestParam("taskType") Integer taskType,
                                        @RequestParam("taskId") Long taskId,
                                        @RequestParam("type") Integer type,
                                        @RequestParam("terminalType") Integer terminalType,
                                        @RequestParam("pageNo") Integer pageNo,
                                        @RequestParam("pageSize") Integer pageSize) {
        return informRecordService.getPage(taskType, taskId, type, terminalType, pageNo, pageSize);
    }

    @Override
    @GetMapping("/cancel")
    public Integer cancel(@RequestParam("id") Long id) {
        return informRecordService.cancel(id);
    }

    @Override
    @GetMapping("/cancelByCommentId")
    public Integer cancelByCommentId(@RequestParam("taskType") Integer taskType,
                                     @RequestParam("taskId") Long taskId,
                                     @RequestParam("type") Integer type,
                                     @RequestParam(value = "commentId",required = false) Long commentId) {

        return informRecordService.cancelByCommentId(taskType, taskId, type, commentId);
    }

//    /**
//     * 获取<业务id,举报数></>>Map
//     * @param bizType
//     * @return
//     */
//    @Override
//    @GetMapping("/getPersonalDataMap")
//    public Map<Long, Integer> getPersonalDataMap(@RequestParam("bizType") Integer bizType) {
//        return informRecordService.getCountsMap(bizType);
//    }
}

