package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 回复
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
@Data

@TableName("new_reply")
public class NewReply {

    private static final long serialVersionUID = 1L;

	private Long id;

    
	@TableField("biz_id")
	private Long bizId;

    
	@TableField("biz_name")
	private String bizName;

    
	@TableField("biz_type")
	private Integer bizType;
    
    
	@TableField("comment_id")
	private Long commentId;
    
    
	@TableField("commenter_id")
	private Long commenterId;

    
	@TableField("reply_parent_id")
	private Long replyParentId;
    
    
	private String content;

    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;
    
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;
    
    @TableField(value = "update_by_id", fill = FieldFill.UPDATE)
    private Long updateById;

    @TableField(value = "update_by_name", fill = FieldFill.UPDATE)
    private String updateByName;

    @TableField(value = "update_time", fill = FieldFill.UPDATE)
    private Date updateTime;

    
	private Integer state;

    
	@TableField("user_avatar")
    private String userAvatar;
    
    
	@TableField("commenter_name")
    private String commenterName;

    
    @TableField("is_read")
    private Integer isRead;

    
    @TableField(exist = false)
    private Boolean isAuthor = false;

    
    @TableField(exist = false)
    private Boolean isSelf = false;

    
    @TableField(exist = false)
    private Boolean hasForbidden = false;
}
