package com.yizhi.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.application.domain.NewCommentAdmire;
import com.yizhi.application.mapper.CommentAdmireMapper;
import com.yizhi.application.service.ICommentAdmireService;
import com.yizhi.comment.application.constans.Constant;
import com.yizhi.comment.application.vo.domain.NewCommentAdmireVo;
import com.yizhi.core.application.context.ContextHolder;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.comment.application.vo.AdmireVO;
import com.yizhi.comment.application.vo.StatisticsForumAccountVo;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 评论点赞记录表 服务实现类
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
@Service
public class CommentAdmireServiceImpl extends ServiceImpl<CommentAdmireMapper, NewCommentAdmire> implements ICommentAdmireService {

    @Override
    public Map<Long, AdmireVO> getCountsByCommentId(Integer type, List<Long> commentIds,Boolean isExport) {

        Map<Long, AdmireVO> commentAdmireMap = null;
        Long accountId = 0L;
        if (!CollectionUtils.isEmpty(commentIds)) {
            if (!isExport){
                accountId =  ContextHolder.get().getAccountId();
            }
            NewCommentAdmireVo commentAdmire = new NewCommentAdmireVo();
            commentAdmire.setState(Constant.UP);
            commentAdmire.setBizType(type);
            EntityWrapper<NewCommentAdmire> wrapper = new EntityWrapper(commentAdmire);

            wrapper.in("comment_id", commentIds);
            List<NewCommentAdmire> newCommentAdmireVos = this.selectList(wrapper);
            if (!CollectionUtils.isEmpty(newCommentAdmireVos)) {
                commentAdmireMap = new HashMap<>(newCommentAdmireVos.size());
                for (NewCommentAdmire a : newCommentAdmireVos) {
                    if (commentAdmireMap.containsKey(a.getCommentId())) {
                        AdmireVO vo = commentAdmireMap.get(a.getCommentId());
                        if (vo != null) {
                            Integer admireNums = vo.getAdmireNums();
                            vo.setAdmireNums(admireNums + 1);
                            vo.setHasAdmire(accountId.equals(a.getAccountId()));
                            commentAdmireMap.put(a.getCommentId(), vo);
                        }
                    } else {
                        AdmireVO vo = new AdmireVO();
                        vo.setAdmireNums(1);
                        vo.setHasAdmire(accountId.equals(a.getAccountId()));
                        commentAdmireMap.put(a.getCommentId(), vo);
                    }
                }
            }
        }
        return commentAdmireMap;
    }

    @Override
    public Map<Long, StatisticsForumAccountVo> getPersonalDataMap(Integer bizType, Map<Long, StatisticsForumAccountVo> map) {

        NewCommentAdmireVo commentAdmire = new NewCommentAdmireVo();
        commentAdmire.setState(Constant.UP);
        commentAdmire.setBizType(bizType);
        EntityWrapper<NewCommentAdmire> wrapper = new EntityWrapper(commentAdmire);
        List<NewCommentAdmire> newCommentAdmireVos = this.selectList(wrapper);
        if (!CollectionUtils.isEmpty(newCommentAdmireVos)) {
            for (NewCommentAdmire a : newCommentAdmireVos) {
                if (map.containsKey(a.getAccountId())) {
                    StatisticsForumAccountVo vo = map.get(a.getAccountId());
                    if (vo != null) {
                        Integer admireNums = vo.getAdmireNum();
                        admireNums = admireNums == null ? 0 : admireNums;
                        vo.setAdmireNum(admireNums + 1);
                        map.put(a.getAccountId(), vo);
                    }
                } else {
                    StatisticsForumAccountVo vo = new StatisticsForumAccountVo();
                    vo.setAdmireNum(1);
                    map.put(a.getAccountId(), vo);
                }
            }
        }
        return map;
    }

    @Override
    public Map<Long, Integer> getCountsMap(Integer type) {
        Map<Long, Integer> commentAdmireMap = null;
        NewCommentAdmireVo commentAdmire = new NewCommentAdmireVo();
        commentAdmire.setState(Constant.NOT_DELETED);
        commentAdmire.setBizType(type);
        EntityWrapper<NewCommentAdmire> wrapper = new EntityWrapper(commentAdmire);
        List<NewCommentAdmire> newCommentAdmireVos = this.selectList(wrapper);
        if (!CollectionUtils.isEmpty(newCommentAdmireVos)) {
            for (NewCommentAdmire a : newCommentAdmireVos) {
                if (commentAdmireMap.containsKey(a.getCommentId())) {
                    Integer num = commentAdmireMap.get(a.getCommentId());
                    commentAdmireMap.put(a.getCommentId(), num + 1);
                } else {
                    commentAdmireMap.put(a.getCommentId(), 1);
                }
            }
        }
        return commentAdmireMap;
    }
}
